/* En nthread-impl.h */

// Añadir campos oxy e hydro para el descriptor del thread
typedef struct
{
	... Oxygen oxy;
	Hydrogen hydro;
} *nThread;

// Añadir nuevos estados para los threads
typedef enum
{
	... WAIT_HYDRO,
	WAIT_OXY
} State;

/* FIN nthread-impl.h */

NthQueue hydroQ; // = MakeQueue()
NthQueue oxyQ;	 // = MakeQueue()

void nOxygen(Oxygen *oxy, Hydrogen **pH1, Hydrogen **pH2)
{
	// Garantizar exclusión mutua con S_C y E_C en ambas funciones
	START_CRITICAL

	nThread thisTh = nSelf();

	if (nth_queueLength(hydroQ) < 2)
	{
		nth_putBack(oxyQ, thisTh);
		// Suspender tarea si no están los 2 hidrógenos
		suspend(WAIT_HYDRO);
		schedule();
	}

	nThread t1 = nth_getFront(hydroQ); // Extraer 2 tareas hidrógeno
	nThread t2 = nth_getFront(hydroQ);

	t1->oxy = t2->oxy = oxy; // Depositar oxígeno en tareas hidrógeno

	*pH1 = t1->hydro; // Entregar hidrógenos en *pH1 y *pH2
	*pH2 = t2->hydro;

	// Retomar las 2 tareas hidrógeno (no es relevante el orden en que se retoman)
	setReady(t1);
	setReady(t2);
	schedule();

	END_CRITICAL
}

nOxygen *nHydrogen(Hydrogen *h)
{

	START_CRITICAL

	nThread thisTh = nSelf();
	// Registrar hidrógeno para ser extraído por la tarea oxígeno
	thisTh->hydro = h;
	// Colocar tarea en hydroQ para suspenderla en (*)

	nth_putBack(hydroQ, thisTh);
	// Retomar una tarea oxígeno si hay 2 hidrógenos en hydroQ
	if (nth_queueLength(hydroQ) >= 2 && !nth_emptyQueue(oxyQ))
	{
		nTask t = nth_getFront(oxyQ);
		setReady(t);
	}
	suspend(WAIT_OXY);		   // no es relevante cambiar estado
	schedule();				   // (*) Suspende tarea hidrógeno
	Oxygen *oxy = thisTh->oxy; // Rescatar oxígeno y retornarlo

	END_CRITICAL
	return oxy;
}
